<template>
    <div class="row clearfix">
        <div class="col-lg-6 col-md-12">
            <div class="form-group">
                <input
                    type="text"
                    disabled
                    class="form-control"
                    placeholder="company_name"
                    :value="agency.company_name"
                />
            </div>
        </div>
        <div class="col-lg-6 col-md-12">
            <div class="form-group">
                <input
                    type="text"
                    disabled
                    class="form-control"
                    placeholder="comercial_name"
                    :value="agency.comercial_name"
                />
            </div>
        </div>
        <div class="col-lg-4 col-md-12">
            <div class="form-group">
                <input
                    type="text"
                    class="form-control"
                    disabled
                    placeholder="country"
                    :value="agency.country"
                />
            </div>
        </div>
        <div class="col-lg-4 col-md-12">
            <div class="form-group">
                <input
                    type="text"
                    class="form-control"
                    placeholder="city"
                    :value="agency.city"
                    disabled
                />
            </div>
        </div>
        <div class="col-lg-4 col-md-12">
            <div class="form-group">
                <input
                    type="text"
                    class="form-control"
                    placeholder="postal_code"
                    :value="agency.postal_code"
                    disabled
                />
            </div>
        </div>
        <hr />
        <div class="col-md-6 align-self-center">
            <div class="row">
                <div class="col-md-12">
                    <div class="form-group">
                        <input
                            type="text"
                            class="form-control"
                            placeholder="facebook"
                            v-model="agency.facebook"
                        />
                    </div>
                </div>
                <div class="col-md-12">
                    <div class="form-group">
                        <input
                            type="text"
                            class="form-control"
                            placeholder="twitter"
                            v-model="agency.twitter"
                        />
                    </div>
                </div>
                <div class="col-md-12">
                    <div class="form-group">
                        <input
                            type="text"
                            class="form-control"
                            placeholder="linkedin"
                            v-model="agency.linkedin"
                        />
                    </div>
                </div>
                <div class="col-md-12">
                    <div class="form-group">
                        <input
                            type="text"
                            class="form-control"
                            placeholder="instagram"
                            v-model="agency.instagram"
                        />
                    </div>
                </div>
            </div>
        </div>
        <div v-if="agency.logo && !editarLogo" class="col-md-6">
            <img :src="agency.logo" alt="" />
            <button class="btn btn-danger btn-block" @click="editarLogo = true">
                Editar Logo
            </button>
        </div>
        <div v-if="!agency.logo || editarLogo" class="col-md-6">
            <vue-dropzone
                ref="myVueDropzone"
                id="dropzone"
                :options="dropzoneOptions"
                :useCustomSlot="true"
                v-on:vdropzone-success="logoCharged"
            >
                <div class="dropzone-custom-content">
                    <h3 class="text-primary">
                        <i
                            class="zmdi zmdi-cloud-upload"
                            style="font-size:32px"
                        ></i>
                        <br />
                        {{ field.edit ? field.edit.logo : "edit_logo" }}
                    </h3>
                    <h3 class="text-center">
                        {{
                            field.dropzone
                                ? field.dropzone.title
                                : "Drag and drop to upload content!"
                        }}
                    </h3>
                    <div class="text-center">
                        {{
                            field.dropzone
                                ? field.dropzone.subtitle
                                : "...or click to select a file from your computer"
                        }}
                    </div>
                </div>
            </vue-dropzone>
            <button
                class="btn btn-primary btn-block"
                @click="editarLogo = false"
            >
                Cancelar
            </button>
        </div>
        <hr />
        <div class="col-md-12">
            <div class="form-group m-b-10">
                <textarea
                    rows="4"
                    class="form-control no-resize"
                    v-model="agency.description"
                    :placeholder="
                        field.edit ? field.edit.description : 'description'
                    "
                ></textarea>
            </div>
        </div>
        <hr />
        <div class="col-md-12">
            <div class="alert alert-danger" v-if="errorMsg">
                <span class="text-center"
                    ><strong>Oh no! </strong>{{ errorMsg }}</span
                >
            </div>
            <div class="alert alert-success" v-if="successMsg">
                <span class="text-center">{{ successMsg }}</span>
            </div>
        </div>

        <div class="col-md-12">
            <button
                class="btn btn-primary btn-round"
                @click.prevent="postChanges"
            >
                Save Changes
            </button>
        </div>
    </div>
</template>
<script>
import vue2Dropzone from "vue2-dropzone";
import "vue2-dropzone/dist/vue2Dropzone.min.css";
export default {
    components: {
        vueDropzone: vue2Dropzone
    },
    props: ["a", "lang"],
    mounted() {
        localStorage.setItem("agency_selected", JSON.stringify(this.agency));
    },
    data() {
        return {
            successMsg: null,
            errorMsg: null,
            editarLogo: null,
            agency: this.a,
            field: this.lang,
            dropzoneOptions: {
                url: "/api/files/stored",
                addRemoveLinks: true,
                thumbnailWidth: 150,
                maxFilesize: 0.5,
                acceptedFiles: "image/*",
                capture: true,
                uploadMultiple: false,
                maxFiles: 1
            }
        };
    },
    methods: {
        logoCharged(file, res) {
            this.agency.logo = res;
        },
        postChanges() {
            this.successMsg, (this.errorMsg = null);
            axios
                .put("/api/agency/" + this.agency.id, this.agency)
                .then(res => {
                    this.successMsg = res.data.msg;
                    setTimeout(() => {
                        this.successMsg = null;
                    }, 5000);
                })
                .catch(err => {
                    console.log(err.response);
                    this.errorMsg = err.response.data.message;
                });
        }
    }
};
</script>
